---
title: Element.setAttribute()
slug: Web/API/Element/setAttribute
tags:
  - API
  - DOM
  - Element
  - Method
  - NeedsBrowserCompatibility
  - NeedsSpecTable
  - Reference
  - setAttribute
---
<p>{{APIRef("DOM")}}</p>

<p><span class="seoSummary">Sets the value of an attribute on the specified element. If the attribute already exists, the value is updated; otherwise a new attribute is added with the specified name and value.</span></p>

<p>To get the current value of an attribute, use {{domxref("Element.getAttribute", "getAttribute()")}}; to remove an attribute, call {{domxref("Element.removeAttribute", "removeAttribute()")}}.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox"><em>Element</em>.setAttribute(<em>name</em>, <em>value</em>);
</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code>name</code></dt>
 <dd>A {{domxref("DOMString")}} specifying the name of the attribute whose value is to be set. The attribute name is automatically converted to all lower-case when <code>setAttribute()</code> is called on an HTML element in an HTML document.</dd>
 <dt><code>value</code></dt>
 <dd>A {{domxref("DOMString")}} containing the value to assign to the attribute. Any non-string value specified is converted automatically into a string.</dd>
</dl>

<p>Boolean attributes are considered to be <code>true</code> if they're present on the element at all, regardless of their actual <code>value</code>; as a rule, you should specify the empty string (<code>""</code>) in <code>value</code> (some people use the attribute's name; this works but is non-standard). See the {{anch("Example", "example")}} below for a practical demonstration.</p>

<p>Since the specified <code>value</code> gets converted into a string, specifying <code>null</code> doesn't necessarily do what you expect. Instead of removing the attribute or setting its value to be {{jsxref("null")}}, it instead sets the attribute's value to the string <code>"null"</code>. If you wish to remove an attribute, call {{domxref("Element.removeAttribute", "removeAttribute()")}}.</p>

<h3 id="Return_value">Return value</h3>

<p>{{jsxref("undefined")}}.</p>

<h3 id="Exceptions">Exceptions</h3>

<dl>
 <dt><code>InvalidCharacterError</code></dt>
 <dd>The specified attribute <code>name</code> contains one or more characters which are not valid in attribute names.</dd>
</dl>

<h2 id="Example">Example</h2>

<p>In the following example, <code>setAttribute()</code> is used to set attributes on a {{HTMLElement("button")}}.</p>

<h3 id="HTML">HTML</h3>

<pre class="brush: html">&lt;button&gt;Hello World&lt;/button&gt;</pre>

<h3 id="JavaScript">JavaScript</h3>

<pre class="brush:js">var b = document.querySelector("button");

b.setAttribute("name", "helloButton");
b.setAttribute("disabled", "");
</pre>

<p>This demonstrates two things:</p>

<ul>
 <li>The first call to <code>setAttribute()</code> above shows changing the <code>name</code> attribute's value to "helloButton". You can see this using your browser's page inspector (<a href="https://developers.google.com/web/tools/chrome-devtools/inspect-styles">Chrome</a>, <a href="https://docs.microsoft.com/en-us/microsoft-edge/f12-devtools-guide/dom-explorer">Edge</a>, <a href="/en-US/docs/Tools/Page_Inspector">Firefox</a>, <a href="https://developer.apple.com/library/content/documentation/AppleApplications/Conceptual/Safari_Developer_Guide/Introduction/Introduction.html">Safari</a>).</li>
 <li>To set the value of a Boolean attribute, such as <code>disabled</code>, you can specify any value. An empty string or the name of the attribute are recommended values. All that matters is that if the attribute is present at all, <em>regardless of its actual value</em>, its value is considered to be <code>true</code>. The absence of the attribute means its value is <code>false</code>. By setting the value of the <code>disabled</code> attribute to the empty string (<code>""</code>), we are setting <code>disabled</code> to <code>true</code>, which results in the button being disabled.</li>
</ul>

<p>{{ EmbedLiveSample('Example', '300', '50') }}</p>

<p>{{DOMAttributeMethods}}</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('DOM WHATWG','#dom-element-setattribute','setAttribute()')}}</td>
   <td>{{Spec2('DOM WHATWG')}}</td>
   <td></td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.Element.setAttribute")}}</p>

<h3 id="Notes">Gecko notes</h3>

<p>Using <code>setAttribute()</code> to modify certain attributes, most notably <code>value</code> in XUL, works inconsistently, as the attribute specifies the default value. To access or modify the current values, you should use the properties. For example, use <code>Element.value</code> instead of <code>Element.setAttribute()</code>.</p>
